#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    //ENVIRONMENT
    ofBackground(0);
    //SOUND
    myTrack.load("21226__djgriffin__120brksub.aif");
    myTrack.setLoop(true);
    myTrack.setVolume(0.5);
    myTrack.play();
    //VARIABLES
    nBands=32; //use multiples of 8 (maximum is 512)
    height=new float[nBands];
    prevSpectrum=new float[nBands];
}

//--------------------------------------------------------------
void ofApp::update(){
    spectrum=ofSoundGetSpectrum(nBands);
}

//--------------------------------------------------------------
void ofApp::draw(){
    for(int i=0;i<nBands;i++){
        float posX=ofMap(i,0,nBands,0,ofGetWidth());
        ofSetColor(0,ofMap(i,0,nBands,0,255),255);
        if(ofGetFrameNum()%20==0){
            height[i]=spectrum[i];
            prevSpectrum[i]=spectrum[i];
        }else{
            height[i]+=(spectrum[i]-prevSpectrum[i])/20;
        }
        
        ofDrawRectangle(posX, ofGetHeight(), 20, -height[i]*500*(i+1));
    }
}

//--------------------------------------------------------------
void ofApp::keyPressed(int key){

}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){

}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseEntered(int x, int y){

}

//--------------------------------------------------------------
void ofApp::mouseExited(int x, int y){

}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 

}
